// Скетч пульта интервалометра для SONY NEX
// http://samopal.pro/sony-nex2


// Библиотека работы с 7-сегментным индикатором
// https://github.com/sparkfun/SevSeg
#include <SevSeg.h>
SevSeg myDisplay;

// Библиотека работы с ИК фотоаппаратов
// http://sebastian.setz.name/arduino/my-libraries/multi-camera-ir-control/
#include <multiCameraIrControl.h>
Sony NEX5(3);

#define DEBUG 1

// Библиотека работы с пультом 315/433
#include <RCSwitch.h>
RCSwitch mySwitch = RCSwitch();

// Коды клавиш пульта 315МГц
#define CodeA 5592332
#define CodeB 5592512
#define CodeC 5592323
#define CodeD 5592368

unsigned long ms, ms1 = 0, ms2 = 0, ms3 = 0;
boolean modeA = false,
        modeB = false,
        modeC = false,
        modeD = false,
        modeS = false;
boolean flag_d = true;
int     countB = 0;
int     countD = 0;
char tempString[5] = {'-','-','-','-'}; 
unsigned int tm2    = 5000;

void setup()
{
#ifdef DEBUG
    Serial.begin(9600);
    Serial.println("SONY IR-remote init ...");
#endif    
    mySwitch.enableReceive(0);  
    pinMode(13, OUTPUT); 
    digitalWrite(13, LOW);    
    myDisplay.Begin(COMMON_CATHODE, 4, 14, 15, 16, 17, 4, 5, 6, 7, 8, 9, 10, 11);
    myDisplay.SetBrightness(100); 
    myDisplay.DisplayString(tempString, 0); 
}


void loop(){
    myDisplay.DisplayString(tempString, 0); 
    ms = millis();

 
// Принимаем коды с радиопульта
   if (mySwitch.available()) {
      int value = mySwitch.getReceivedValue();
      if( flag_d ){
         SetPultCmd( value );
         digitalWrite(13, HIGH);      
         flag_d = false;
      }   
      mySwitch.resetAvailable();
   }
  
  
  
// Задержка 250мс для устранения дребезга    
    if( ( ms - ms1 ) >250 || ms < ms1 ){  
       ms1 = ms;
       if( !flag_d ){
          digitalWrite(13, LOW);      
          flag_d = true;
// Режим установки
          if( modeS ){
// Увеличить tm2
             if( modeA ){
                modeA = false;
                if( tm2<65000)tm2 += 1000;
                else tm2 = 65000;
                sprintf(tempString, "_%2d_", tm2/1000); 
             }
// Уменьшить tm2
             if( modeB ){
                modeB = false;
                if( tm2 >=2000 )tm2 -= 1000;
                else tm2 = 1000;
                sprintf(tempString, "_%2d_", tm2/1000); 
             }
// Установить tm2 по умолчанию
             if( modeC ){
                modeC = false;
                tm2   = 5000;
                sprintf(tempString, "_%2d_", tm2/1000); 
             }

// Вернуться в нормальный режим
             if( modeD ){
                modeD = false;
                modeS = false;
                tempString[0]=32;tempString[1]=32;tempString[2]=32;tempString[3]=32;
              }
          }
          else {
 // Режим А - один кадр          
             if( modeA ){
                modeA  = false; 
#ifdef DEBUG
                Serial.println("Photo OK");  
#endif             
                NEX5.shutterNow();
             }
// Режим C - Видео Старт/стоп          
             if( modeC ){
                modeA  = false;
#ifdef DEBUG
                Serial.println("Video ON/OFF");  
#endif
                NEX5.toggleVideo();
             }
// Режим D - выключить все          
             if( modeD ){
                modeD = false; 
                countD++;
#ifdef DEBUG
                Serial.print("Mode D: ");  
                Serial.println(countD);  
#endif
// Режим D в течении 5 сек - SETUP
                if( countD > 18 ){
                   modeS = true;
                   sprintf(tempString, "_%2d_", tm2/1000); 
#ifdef DEBUG
                Serial.println("Setup mode");  
#endif
                }
             }
          }
       }
       else {
          if( countD > 0 )countD--;
       }
    }
    
// Погасить дисплей через 2 сек
   if( (( ms - ms3 ) > 2000 || ms < ms3)&&!modeS&&!modeB ){
      tempString[0]=32;tempString[1]=32;tempString[2]=32;tempString[3]=32;
   }
    
// Команда фото каждые 5 сек (TimeLife)      
   if( (( ms - ms2 ) > tm2 || ms < ms2)&&!modeS ){
      ms2 = ms; 
      if( modeB ){
#ifdef DEBUG
         Serial.println("Serial 5 OK");  
#endif
         countB++;
         if( countB < 1000 )sprintf(tempString, "B%3d", ++countB); 
         else sprintf(tempString, "%4d", ++countB);
         NEX5.shutterNow();
      }
   }   

}

void SetPultCmd( int value ){
   if (value == 0) {
#ifdef DEBUG
      Serial.print("Unknown encoding");
#endif
   } 
   else {
#ifdef DEBUG
      Serial.print("Received ");
      Serial.print( mySwitch.getReceivedValue() );
      Serial.print(" / ");
      Serial.print( mySwitch.getReceivedBitlength() );
      Serial.print("bit ");
      Serial.print("Protocol: ");
      Serial.println( mySwitch.getReceivedProtocol() );
#endif
       ms3 = ms;
       switch( value ){
         case CodeA :
            modeA = true;
            modeB  = false;     
            modeC  = false;
            modeD  = false;
            countB = 0;
            tempString[0]='A';tempString[1]=32;tempString[2]=32;tempString[3]=32;
#ifdef DEBUG
            Serial.println("Mode A");
#endif
            break;
         case CodeB :
            modeA  = false;
            modeB  = true;     
            modeC  = false;
            modeD  = false;
            tempString[0]='B';tempString[1]=32;tempString[2]=32;tempString[3]=32;
#ifdef DEBUG
            Serial.println("Mode B");
#endif
            break;
         case CodeC :
            modeA  = false;
            modeB  = false;     
            modeC  = true;
            modeD  = false;
            countB = 0;
            tempString[0]='C';tempString[1]=32;tempString[2]=32;tempString[3]=32;
#ifdef DEBUG
            Serial.println("Mode C");
#endif
            break;
         case CodeD :
            modeA  = false;
            modeB  = false;     
            modeC  = false;
            modeD  = true;
            countB = 0;
            tempString[0]='O';tempString[1]='F';tempString[2]='F';tempString[3]=32;
#ifdef DEBUG
            Serial.println("Mode D");
#endif
            break;
          
      }
   }
}






